var pinocchio = module.exports = function yourErrorsAreBadAndYouShouldFeelBad(badErr) {
  var err,
      trace = (new Error()).stack,
      metadata,
      message,
      fails = [];

  if (badErr instanceof Error) {
    return badErr;
  }
  else if (typeof badErr === 'string') {
    fails.push('is a string');
    try {
      metadata = JSON.parse(badErr);
      fails.push('is a JSON-encoded string');
    }
    catch (err) {
      if (!badErr.split(' ').some(function (fragment) {
        try {
          metadata = JSON.parse(fragment);
          fails.push('is a string with a JSON fragment inside it');
          message = badErr;
          return true;
        }
        catch (err) {
          return false;
        }
      })) { message = badErr; }
    }
  }
  else {
    fails.push('is a non-error object');
    
    metadata = badErr;
  }

  metadata = metadata || {};
  message = message || metadata.message;

  if (!message) {
    fails.push('does not have a message property');
  }

  err = new Error(message);
  err.stack = metadata.stack || trace;
  Object.keys(metadata).forEach(function (k) {
    if (typeof err[k] == 'undefined') {
      err[k] = metadata[k];
    }
  });

  err.fails = fails;

  return err;
};

pinocchio.isARealError = pinocchio;
